%if 0%{?el7}
%define dist .el7
%endif
%if 0%{?fedora} >= 27
%define debug_package %{nil}
%endif

%define utf8 0
%define source mod_uploader-3.1.1.tgz

%if 0%{?fedora} <= 16 || 0%{?rhel} <= 6
%define apxs /usr/sbin/apxs
%define apctl /usr/sbin/apachectl
%define aprconf /usr/bin/apr-1-config
%endif
%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
%define apxs /usr/bin/apxs
%define apctl /usr/sbin/apachectl
%define aprconf /usr/bin/apr-1-config
%endif

%define gitver .gita230a93

# git clone https://github.com/kimata/mod_uploader mod_uploader-3.2.0
# tar acvf mod_uploader-3.2.0%%{?gitver}.tar.xz mod_uploader-3.2.0 --exclude=.git
# cd mod_uploader-3.2.0 && git log -1 --pretty=format:".git%h"

Summary: A file upload application works as Apache module
Name:		mod_uploader
Version:	3.2.0
Release:	1%{?gitver}%{?dist}
License:	The zlib/libpng License
Group:		System Environment/Daemons
Packager:       momo-i <webmaster@momo-i.org>
Vendor:         momo-i, http://www.momo-i.org/
URL:		http://sourceforge.jp/projects/mod-uploader/

Source:		%{name}-%{version}%{?gitver}.tar.xz
Source1:	10-mod_uploader.conf
Source2:	mod_uploader.conf
#Patch0:		%%{name}-%%{version}-httpd24.patch
#Patch1:		%%{name}-%%{version}-file.patch
#Patch2:		%%{name}-%%{version}-make.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: gcc-c++, make, libtool, httpd-devel, ImageMagick-c++-devel, apr-devel, apr-util-devel
BuildRequires: dos2unix nkf
BuildRequires: gcc
Requires: httpd, ImageMagick-c++

%description
mod_uploader is a file upload application works as Apache module.
The following features are provided:
- It works faster than the thing made with Perl or PHP or Ruby,
  because it is made with C++ and works as Apache module. 
- It includes simple template engine, so you can change page layouts
  without re-compilation. 
- it can show progress report when uploading. 

%prep
%setup -q -n %{name}-%{version}
#%if 0%{?fedora} >= 18 || 0%{?rhel} >= 7
#%patch0 -p1 -b .httpd24
#%patch1 -p1
#%patch2 -p1
#%endif

dos2unix `find . -type f`

%if 0%{utf8} == 1
for f in `find . -type f`
do
	nkf -w $f > $f.w
	cp  $f.w $f && rm $f.w
	sed -i -e 's/euc-japan-unix/utf-8/g;' \
		-e 's/euc-japan-unix/utf-8/g;' \
		-e 's/euc-jp/utf-8/g;' \
		-e 's/EUC-JP/utf-8/g;' \
	$f
done
%endif

%build
#CC=%{_bindir}/gcc
#CXX=%{_bindir}/gcc
#export CC CXX
%configure \
--enable-thumbnail \
--with-apxs=%{apxs} \
--with-apctl=%{apctl} \
--with-aprconf=%{aprconf}

sed -i -e 's,-O3,-O4,' src/GNUmakefile

%{__make} clean
%{__make} all

%install
%{__rm} -rf $RPM_BUILD_ROOT
%{__mkdir} -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d
%{__mkdir} -p $RPM_BUILD_ROOT%{_libdir}/httpd/modules
%{__mkdir} -p $RPM_BUILD_ROOT%{_datadir}/%{name}/{css,img,js,swf,test,tmpl}
%{__mkdir} -p $RPM_BUILD_ROOT%{_datadir}/%{name}/test/{data,file,thumb,temp}
%if 0%{?fedora} >= 18 || 0%{?rhel} >= 7
%{__install} -D -m0644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.modules.d/10-mod_uploader.conf
%endif
%{__install} -D -m0644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/mod_uploader.conf
%{__install} -m0755 mod_uploader.so $RPM_BUILD_ROOT%{_libdir}/httpd/modules/mod_uploader.so
%{__install} -m0644 css/default.css $RPM_BUILD_ROOT%{_datadir}/%{name}/css/default.css
%{__install} -m0644 img/bar_back.png $RPM_BUILD_ROOT%{_datadir}/%{name}/img/
%{__install} -m0644 img/bar_fore.png $RPM_BUILD_ROOT%{_datadir}/%{name}/img/
%{__install} -m0644 img/favicon.ico $RPM_BUILD_ROOT%{_datadir}/%{name}/img/
%{__install} -m0644 img/icon_download.png $RPM_BUILD_ROOT%{_datadir}/%{name}/img/
%{__install} -m0644 img/icon_error.png $RPM_BUILD_ROOT%{_datadir}/%{name}/img/
%{__install} -m0644 img/icon_feed.png $RPM_BUILD_ROOT%{_datadir}/%{name}/img/
%{__install} -m0644 img/icon_valid_css.png $RPM_BUILD_ROOT%{_datadir}/%{name}/img/
%{__install} -m0644 img/icon_valid_xhtml.png $RPM_BUILD_ROOT%{_datadir}/%{name}/img/
%{__install} -m0644 img/title.png $RPM_BUILD_ROOT%{_datadir}/%{name}/img/
%{__install} -m0644 js/progress.js $RPM_BUILD_ROOT%{_datadir}/%{name}/js
%{__install} -m0644 swf/UploadPanel.swf $RPM_BUILD_ROOT%{_datadir}/%{name}/swf
%{__install} -m0644 tmpl/admin.htm $RPM_BUILD_ROOT%{_datadir}/%{name}/tmpl
%{__install} -m0644 tmpl/download.htm $RPM_BUILD_ROOT%{_datadir}/%{name}/tmpl
%{__install} -m0644 tmpl/error.htm $RPM_BUILD_ROOT%{_datadir}/%{name}/tmpl
%{__install} -m0644 tmpl/index.htm $RPM_BUILD_ROOT%{_datadir}/%{name}/tmpl
%{__install} -m0644 tmpl/index_swf.htm $RPM_BUILD_ROOT%{_datadir}/%{name}/tmpl
%{__install} -m0644 tmpl/info.htm $RPM_BUILD_ROOT%{_datadir}/%{name}/tmpl
%{__install} -m0644 tmpl/progress.htm $RPM_BUILD_ROOT%{_datadir}/%{name}/tmpl
%{__install} -m0644 tmpl/thumbnail.htm $RPM_BUILD_ROOT%{_datadir}/%{name}/tmpl

%post
if [ $1 -eq 1 ]; then
sed -i -e "s,@datadir@,%{_datadir},g" \
       -e "s,@hostname@,`uname -n`," \
       %{_sysconfdir}/httpd/conf.d/mod_uploader.conf
fi

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%doc AUTHORS ChangeLog
%{!?_licensedir:%global license %%doc}
%license COPYING
%config(noreplace) %{_sysconfdir}/httpd/conf.d/mod_uploader.conf
%if 0%{?fedora} >= 18 || 0%{?rhel} >= 7
%config %{_sysconfdir}/httpd/conf.modules.d/10-mod_uploader.conf
%endif
%{_libdir}/httpd/modules/mod_uploader.so
%attr(-, apache, apache) %{_datadir}/%{name}/*

%changelog
* Thu Oct 01 2015 momo-i <webmaster@momo-i.org> - 3.2.0-1
- Update version number to 3.2.0

* Wed Sep 16 2015 momo-i <webmaster@momo-i.org> - 3.1.1-13.gita230a93
- Update to a230a93

* Thu Sep 03 2015 momo-i <webmaster@momo-i.org> - 3.1.1-12
- Update dist for centos7

* Mon Aug 10 2015 momo-i <webmaster@momo-i.org> - 3.1.1-11
- Rebuilt for fc23

* Wed Apr 15 2015 momo-i <webmaster@momo-i.org> - 3.1.1-10
- Rebuilt for fc22

* Thu Sep 25 2014 momo-i <webmaster@momo-i.org> - 3.1.1-9
- Update for rhel7

* Thu Mar  7 2013 momo-i <webmaster@momo-i.org> - 3.1.1-8
- Testing for fedora18

* Mon Oct 25 2010 momo-i <webmaster@momo-i.org> - 3.1.1-2
- Convert character set to utf8.
- Template.
* Sun Feb 17 2008 Tetsuya Kimata <kimata@acapulco.dyndns.org> - 3.0.4-1
- Initial package.
